'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _reactNative = require('react-native');

var _eventEmitter = require('event-emitter');

var _eventEmitter2 = _interopRequireDefault(_eventEmitter);

var _resolveAssetSource = require('react-native/Libraries/Image/resolveAssetSource');

var _resolveAssetSource2 = _interopRequireDefault(_resolveAssetSource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RNAudio = _reactNative.NativeModules.RNAudio;


var n = function n(v, def) {
  return parseFloat(v === undefined || isNaN(v) ? def || 0 : v);
};
var s = function s(v, def) {
  return '' + (v === undefined ? def || '' : v);
};
var b = function b(v, def) {
  return v === undefined ? !!def || false : !!v;
};

var audioMap = {};

var emitter = new _reactNative.NativeEventEmitter(RNAudio);
emitter.addListener('RNAudioEvent', function (evt) {
  var audio = audioMap[evt.audioId];
  if (!audio) return;
  audio._emit(evt);
});

var TYPES = ['abort', 'canplay', 'canplaythrough', 'durationchange', 'emptied', 'ended', 'error', 'loadeddata', 'loadedmetadata', 'loadstart', 'pause', 'play', 'playing', 'progress', 'ratechange', 'seeked', 'seeking', 'stalled', 'suspend', 'timeupdate', 'volumechange', 'waiting'];

var Audio = function () {
  _createClass(Audio, [{
    key: 'on' + function (type) {
      return type;
    }(TYPES),
    set: function set(listener) {
      var current = this['_on' + type];
      if (current) this._emitter.off(type, current);
      if (listener) this._emitter.on(type, listener);
      this['_on' + type] = listener;
    }
  }, {
    key: 'on' + function (type) {
      return type;
    }(TYPES),
    get: function get() {
      return this['_on' + type];
    }
  }]);

  function Audio(url) {
    var _this = this;

    _classCallCheck(this, Audio);

    this._source = url;
    this._emitter = (0, _eventEmitter2.default)();
    this._audioId = undefined;
    this._data = {
      cache: undefined,
      audioTracks: undefined,
      autoplay: undefined,
      buffered: undefined,
      controller: undefined,
      controls: undefined,
      crossOrigin: undefined,
      currentSrc: undefined,
      currentTime: undefined,
      defaultMuted: undefined,
      defaultPlaybackRate: undefined,
      duration: undefined,
      ended: undefined,
      error: undefined,
      loop: undefined,
      mediaGroup: undefined,
      muted: undefined,
      networkState: undefined,
      paused: undefined,
      playbackRate: undefined,
      played: undefined,
      preload: undefined,
      seekable: undefined,
      seeking: undefined,
      src: undefined,
      textTracks: undefined,
      volume: undefined
    };
    this._init().then(function () {
      _this._emitter.emit('init');
      if (_this._source) _this.src = _this._source;
    }, function (err) {
      console.error('Audio error:', err);
    });
  }

  _createClass(Audio, [{
    key: '_init',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var ret;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return RNAudio.create();

              case 2:
                ret = _context.sent;

                this._audioId = ret.audioId;
                audioMap[this._audioId] = this;

              case 5:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _init() {
        return _ref.apply(this, arguments);
      }

      return _init;
    }()
  }, {
    key: '_emit',
    value: function _emit(evt) {
      this._data = _extends({}, this._data, evt);
      // console.log('emitting:', evt.type, this._data)
      this._emitter.emit(evt.type, evt);
    }
  }, {
    key: 'addEventListener',
    value: function addEventListener(type, listener) {
      this._emitter.on(type, listener);
    }
  }, {
    key: 'removeEventListener',
    value: function removeEventListener(type, listener) {
      this._emitter.off(type, listener);
    }
  }, {
    key: 'addTextTrack',
    value: function addTextTrack(v) {
      if (!this._audioId) return;
      RNAudio.addTextTrack(this._audioId, v);
    }
  }, {
    key: 'canPlayType',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(mediaType) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.waitForInit();

              case 2:
                _context2.next = 4;
                return RNAudio.canPlayType(this._audioId, s(mediaType));

              case 4:
                return _context2.abrupt('return', _context2.sent);

              case 5:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function canPlayType(_x) {
        return _ref2.apply(this, arguments);
      }

      return canPlayType;
    }()
  }, {
    key: 'waitForInit',
    value: function waitForInit() {
      var _this2 = this;

      if (this._audioId) return Promise.resolve();
      return new Promise(function (resolve, reject) {
        _this2._emitter.once('init', resolve);
        _this2._emitter.once('error', reject);
      });
    }
  }, {
    key: 'load',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.waitForInit();

              case 2:
                RNAudio.load(this._audioId);

              case 3:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function load() {
        return _ref3.apply(this, arguments);
      }

      return load;
    }()
  }, {
    key: 'unload',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return RNAudio.unload(this._audioId);

              case 2:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function unload() {
        return _ref4.apply(this, arguments);
      }

      return unload;
    }()
  }, {
    key: 'play',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.waitForInit();

              case 2:
                RNAudio.play(this._audioId);

              case 3:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function play() {
        return _ref5.apply(this, arguments);
      }

      return play;
    }()
  }, {
    key: 'pause',
    value: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.waitForInit();

              case 2:
                RNAudio.pause(this._audioId);

              case 3:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function pause() {
        return _ref6.apply(this, arguments);
      }

      return pause;
    }()
  }, {
    key: 'audioTracks',
    get: function get() {
      return this._data.audioTracks;
    }
  }, {
    key: 'cache',
    set: function set(v) {
      var _this3 = this;

      this.waitForInit().then(function () {
        return RNAudio.setCache(_this3._audioId, b(v));
      });
    },
    get: function get() {
      return this._data.cache;
    }
  }, {
    key: 'autoplay',
    set: function set(v) {
      var _this4 = this;

      this.waitForInit().then(function () {
        return RNAudio.setAutoplay(_this4._audioId, b(v));
      });
    },
    get: function get() {
      return this._data.autoplay;
    }
  }, {
    key: 'buffered',
    get: function get() {
      return this._data.buffered;
    }
  }, {
    key: 'controller',
    get: function get() {
      return this._data.controller;
    }
  }, {
    key: 'controls',
    set: function set(v) {
      var _this5 = this;

      this.waitForInit().then(function () {
        return RNAudio.setControls(_this5._audioId, b(v));
      });
    },
    get: function get() {
      return this._data.controls;
    }
  }, {
    key: 'crossOrigin',
    set: function set(v) {
      var _this6 = this;

      this.waitForInit().then(function () {
        return RNAudio.setCrossOrigin(_this6._audioId, s(v));
      });
    },
    get: function get() {
      return this._data.crossOrigin;
    }
  }, {
    key: 'currentSrc',
    get: function get() {
      return this._data.currentSrc;
    }
  }, {
    key: 'currentTime',
    set: function set(v) {
      var _this7 = this;

      this.waitForInit().then(function () {
        return RNAudio.setCurrentTime(_this7._audioId, n(v));
      });
    },
    get: function get() {
      return this._data.currentTime;
    }
  }, {
    key: 'defaultMuted',
    set: function set(v) {
      var _this8 = this;

      this.waitForInit().then(function () {
        return RNAudio.setDefaultMuted(_this8._audioId, b(v));
      });
    },
    get: function get() {
      return this._data.defaultMuted;
    }
  }, {
    key: 'defaultPlaybackRate',
    set: function set(v) {
      var _this9 = this;

      this.waitForInit().then(function () {
        return RNAudio.setDefaultPlaybackRate(_this9._audioId, n(v, 1));
      });
    },
    get: function get() {
      return this._data.defaultPlaybackRate;
    }
  }, {
    key: 'duration',
    get: function get() {
      return this._data.duration;
    }
  }, {
    key: 'ended',
    get: function get() {
      return this._data.ended;
    }
  }, {
    key: 'error',
    get: function get() {
      return this._data.error;
    }
  }, {
    key: 'loop',
    set: function set(v) {
      var _this10 = this;

      this.waitForInit().then(function () {
        return RNAudio.setLoop(_this10._audioId, b(v));
      });
    },
    get: function get() {
      return this._data.loop;
    }
  }, {
    key: 'mediaGroup',
    set: function set(v) {
      var _this11 = this;

      this.waitForInit().then(function () {
        return RNAudio.setMediaGroup(_this11._audioId, s(v));
      });
    },
    get: function get() {
      return this._data.mediaGroup;
    }
  }, {
    key: 'muted',
    set: function set(v) {
      var _this12 = this;

      this.waitForInit().then(function () {
        return RNAudio.setMuted(_this12._audioId, b(v));
      });
    },
    get: function get() {
      return this._data.muted;
    }
  }, {
    key: 'networkState',
    get: function get() {
      return this._data.networkState;
    }
  }, {
    key: 'paused',
    set: function set(v) {
      var _this13 = this;

      this.waitForInit().then(function () {
        return RNAudio.setPaused(_this13._audioId, b(v));
      });
    },
    get: function get() {
      return this._data.paused;
    }
  }, {
    key: 'playbackRate',
    set: function set(v) {
      var _this14 = this;

      this.waitForInit().then(function () {
        return RNAudio.setPlaybackRate(_this14._audioId, n(v, 1));
      });
    },
    get: function get() {
      return this._data.playbackRate;
    }
  }, {
    key: 'played',
    get: function get() {
      return this._data.played;
    }
  }, {
    key: 'preload',
    set: function set(v) {
      var _this15 = this;

      this.waitForInit().then(function () {
        return RNAudio.setPreload(_this15._audioId, b(v));
      });
    },
    get: function get() {
      return this._data.preload;
    }
  }, {
    key: 'readyState',
    get: function get() {}
  }, {
    key: 'seekable',
    get: function get() {
      return this._data.seekable;
    }
  }, {
    key: 'seeking',
    get: function get() {
      return this._data.seeking;
    }
  }, {
    key: 'src',
    set: function set(v) {
      var _this16 = this;

      if (typeof v === 'undefined' || v === null) {
        this._source = v;
        return;
      }
      if (typeof v === 'string') {
        v = { uri: v };
      }
      this._source = (0, _resolveAssetSource2.default)(v);
      if (this._source.uri.startsWith('file://')) {
        var path = this._source.uri.substr('file://'.length);
        this._source = _extends({}, this._source, { path: path });
      }
      this.waitForInit().then(function () {
        return RNAudio.setSource(_this16._audioId, _this16._source);
      });
    },
    get: function get() {
      return this._data.src;
    }
  }, {
    key: 'textTracks',
    get: function get() {
      return this._data.textTraks;
    }
  }, {
    key: 'volume',
    set: function set(v) {
      var _this17 = this;

      this.waitForInit().then(function () {
        return RNAudio.setVolume(_this17._audioId, n(v));
      });
    },
    get: function get() {
      return this._data.volume;
    }
  }]);

  return Audio;
}();

exports.default = Audio;